/*
  S4.h - Library for the overall S4 Program
  Kevin John
  Sonoma State University
  NASA E/PO
  Released into the public domain.
*/
  #ifndef NetworkParameters_h
  #define NetworkParameters_h
  #include "Arduino.h"

  class NetworkParameters
  {
        public:
            NetworkParameters();
			const __FlashStringHelper* SSID;
			const __FlashStringHelper* DeviceName;
			const __FlashStringHelper* ServerIP;
			const __FlashStringHelper* GatewayIP;
			const __FlashStringHelper* Wep_key;	
			const __FlashStringHelper* ServerPort; 
			const __FlashStringHelper* UseDHCP; 
			const __FlashStringHelper* DeviceIPAddress; 
			const __FlashStringHelper* Protocol; 
			const __FlashStringHelper* WLanAuth; 
			const __FlashStringHelper* DataRate; 
			const __FlashStringHelper* HostPort; 
			const __FlashStringHelper* BroadcastInterval; 
			const __FlashStringHelper* UseExternalAntenna;
			const __FlashStringHelper* FlushSize; 
			const __FlashStringHelper* Channel;
			String getValue(const __FlashStringHelper* value);
             	  
			 
        private:			
                
  };
  #endif